//
// 摜TCYϊ g.koutaki 2012
//

#define min(a, b) (a>b?b:a)
// 1/2 ɏk(Z)
void img_half_rgb
	(
	unsigned char *in,
	int w,
	int h,
	unsigned char *out,
	int *ow,
	int *oh
	)
{
	int x, y, sx1, sy1, sx2, sy2, ptr;
	*ow = w / 2;
	*oh = h / 2;

	for(ptr = y = 0;y < *oh;y++)
	{
		sy1 = y * 2;
		sy2 = min(y * 2 + 1, h - 1);
		for(x = 0;x < *ow;x++, ptr+=3)
		{
			sx1 = x * 2;
			sx2 = min(x * 2 + 1, w - 1);
			out[ptr + 0] = (
				 in[(sx1 + sy1 * w) * 3 + 0]
				+in[(sx2 + sy1 * w) * 3 + 0]
				+in[(sx1 + sy2 * w) * 3 + 0]
				+in[(sx2 + sy2 * w) * 3 + 0]
				) / 4;
			out[ptr + 1] = (
				 in[(sx1 + sy1 * w) * 3 + 1]
				+in[(sx2 + sy1 * w) * 3 + 1]
				+in[(sx1 + sy2 * w) * 3 + 1]
				+in[(sx2 + sy2 * w) * 3 + 1]
				) / 4;
			out[ptr + 2] = (
				 in[(sx1 + sy1 * w) * 3 + 2]
				+in[(sx2 + sy1 * w) * 3 + 2]
				+in[(sx1 + sy2 * w) * 3 + 2]
				+in[(sx2 + sy2 * w) * 3 + 2]
				) / 4;
		};//x
	};//y
}

// N{Ɋg
void img_double_rgb
	(
	unsigned char *in,
	int w,
	int h,
	unsigned char *out,
	int *ow,
	int *oh,
	int scale
	)
{
	int x, y, sx, sy, ptr;
	*ow = w * scale;
	*oh = h * scale;

	for(ptr = y = 0;y < *oh;y++)
	{
		sy = y / scale;
		for(x = 0;x < *ow;x++, ptr+=3)
		{
			sx = x / scale;
			out[ptr + 0] = in[(sx + sy * w) * 3 + 0];
			out[ptr + 1] = in[(sx + sy * w) * 3 + 1];
			out[ptr + 2] = in[(sx + sy * w) * 3 + 2];
		};//x
	};//y
}

//
// s~bh摜
//
void gen_pyramid_rgb(
	unsigned char *img, 
	int w, 
	int h, 
	unsigned char *out, 
	int *Lw, 
	int *Lh, 
	int *Lptr, 
	int  max_L
	)
{
	int L;
	Lw[0]   = w;
	Lh[0]   = h;
	Lptr[0] = 0;
	memcpy(out, img, w * h * 3);
	for(L = 1;L < max_L;L++)
	{
		Lw[L] = Lw[L-1] / 2;
		Lh[L] = Lh[L-1] / 2;
		Lptr[L] = Lptr[L-1] + Lw[L-1] * Lh[L-1] * 3;

		img_half_rgb(
			&out[Lptr[L-1]],  Lw[L-1],  Lh[L-1],
			&out[Lptr[L]],   &Lw[L],   &Lh[L]
			);
	};//L
}
